Index: trunk/MagicSoft/Simulation/Detector/Starfield/Makefile.osf
===================================================================
--- trunk/MagicSoft/Simulation/Detector/Starfield/Makefile.osf	(revision 1708)
+++ trunk/MagicSoft/Simulation/Detector/Starfield/Makefile.osf	(revision 5110)
@@ -3,5 +3,5 @@
 ## Starfield Generator Makefile
 ##
-## $Id: Makefile.osf,v 1.1 2003-01-14 13:48:38 blanch Exp $
+## $Id: Makefile.osf,v 1.2 2004-09-17 17:36:25 moralejo Exp $
 ##   
 ##################################################################
@@ -110,64 +110,2 @@
 
 # DO NOT DELETE THIS LINE -- make depend depends on it.
-
-starfield.o: starfield.h /usr/include/stdlib.h /usr/include/standards.h
-starfield.o: /usr/include/getopt.h /usr/include/sys/types.h
-starfield.o: /usr/include/mach/machine/vm_types.h /usr/include/sys/select.h
-starfield.o: /usr/include/stdio.h /usr/include/sys/seek.h
-starfield.o: /usr/include/va_list.h /usr/include/sys/limits.h
-starfield.o: /usr/include/sys/machine/machlimits.h
-starfield.o: /usr/include/sys/syslimits.h /usr/include/sys/machine/machtime.h
-starfield.o: /usr/include/sys/rt_limits.h /usr/include/string.h
-starfield.o: /usr/include/strings.h /usr/include/math.h /usr/include/dirent.h
-starfield.o: /usr/include/unistd.h /usr/include/sys/access.h convertcorsika.h
-starfield.o: photon.hxx star.hxx parameters.h
-star.o: star.hxx /usr/include/math.h /usr/include/standards.h
-star.o: /usr/include/stdlib.h /usr/include/getopt.h /usr/include/sys/types.h
-star.o: /usr/include/mach/machine/vm_types.h /usr/include/sys/select.h
-star.o: /usr/include/string.h /usr/include/strings.h /usr/include/stdio.h
-star.o: /usr/include/sys/seek.h /usr/include/va_list.h
-star.o: /usr/include/sys/limits.h /usr/include/sys/machine/machlimits.h
-star.o: /usr/include/sys/syslimits.h /usr/include/sys/machine/machtime.h
-star.o: /usr/include/sys/rt_limits.h
-photon.o: photon.hxx /usr/include/math.h /usr/include/standards.h
-photon.o: /usr/include/stdlib.h /usr/include/getopt.h
-photon.o: /usr/include/sys/types.h /usr/include/mach/machine/vm_types.h
-photon.o: /usr/include/sys/select.h
-convertcorsika.o: convertcorsika.h /usr/include/string.h
-convertcorsika.o: /usr/include/standards.h /usr/include/sys/types.h
-convertcorsika.o: /usr/include/mach/machine/vm_types.h
-convertcorsika.o: /usr/include/sys/select.h /usr/include/strings.h photon.hxx
-convertcorsika.o: /usr/include/math.h /usr/include/stdlib.h
-convertcorsika.o: /usr/include/getopt.h
-parameters.o: parameters.h /usr/include/stdio.h /usr/include/standards.h
-parameters.o: /usr/include/sys/seek.h /usr/include/va_list.h
-parameters.o: /usr/include/sys/types.h /usr/include/mach/machine/vm_types.h
-parameters.o: /usr/include/sys/select.h /usr/include/getopt.h
-parameters.o: /usr/include/sys/limits.h /usr/include/sys/machine/machlimits.h
-parameters.o: /usr/include/sys/syslimits.h
-parameters.o: /usr/include/sys/machine/machtime.h
-parameters.o: /usr/include/sys/rt_limits.h
-../include-CORSIKA/COREventHeader.o: ../include-CORSIKA/COREventHeader.hxx
-../include-CORSIKA/COREventHeader.o: /usr/include/stdlib.h
-../include-CORSIKA/COREventHeader.o: /usr/include/standards.h
-../include-CORSIKA/COREventHeader.o: /usr/include/getopt.h
-../include-CORSIKA/COREventHeader.o: /usr/include/sys/types.h
-../include-CORSIKA/COREventHeader.o: /usr/include/mach/machine/vm_types.h
-../include-CORSIKA/COREventHeader.o: /usr/include/sys/select.h
-../include-CORSIKA/COREventHeader.o: /usr/include/math.h
-../include-CORSIKA/CORParticle.o: ../include-CORSIKA/CORParticle.hxx
-../include-CORSIKA/CORParticle.o: /usr/include/stdlib.h
-../include-CORSIKA/CORParticle.o: /usr/include/standards.h
-../include-CORSIKA/CORParticle.o: /usr/include/getopt.h
-../include-CORSIKA/CORParticle.o: /usr/include/sys/types.h
-../include-CORSIKA/CORParticle.o: /usr/include/mach/machine/vm_types.h
-../include-CORSIKA/CORParticle.o: /usr/include/sys/select.h
-../include-CORSIKA/CORParticle.o: /usr/include/math.h
-../include-CORSIKA/CORStatfile.o: ../include-CORSIKA/CORStatfile.hxx
-../include-CORSIKA/CORStatfile.o: /usr/include/stdlib.h
-../include-CORSIKA/CORStatfile.o: /usr/include/standards.h
-../include-CORSIKA/CORStatfile.o: /usr/include/getopt.h
-../include-CORSIKA/CORStatfile.o: /usr/include/sys/types.h
-../include-CORSIKA/CORStatfile.o: /usr/include/mach/machine/vm_types.h
-../include-CORSIKA/CORStatfile.o: /usr/include/sys/select.h
-../include-CORSIKA/CORStatfile.o: /usr/include/math.h